<?php
// serverstats.php - Basic Server Statistics
// Version 1.0.1
// Copyright 2001-2002, Steve Blinch 
// http://code.blitzaffe.com
	
define("INTERVAL_1_MIN",0); // load average for last 1 minute
define("INTERVAL_5_MIN",1); // load average for last 5 minute
define("INTERVAL_15_MIN",2); //  load average for last 15 minute
define("DEFAULT_AVG",INTERVAL_15_MIN); // selects which load average to return by default if no parameters are passed

function is_s($n) {
	if ($n==1) { return ""; } else { return "s"; }
}

function uptime() {
	$res = "";
	$filename = "/proc/uptime";
	$fd = fopen ($filename, "r");
	if ($fd===false) {
		$res="Could not retrieve uptime";
	} else {
		$uptime = fgets($fd, 64);
		fclose ($fd);

		$mults = array(4=>"month",7=>"week",24=>"day",60=>"hour",1=>"minute");
		$n = 2419200;
		$periods = array();
		$shown=false;
		
		$uptime = substr($uptime,0,strpos($uptime," "));
		$res="";
		while (list($k,$v)=each($mults)) {
			$nmbr = floor($uptime / $n); $uptime -= ($nmbr*$n);
			$n = $n / $k;
			if ($nmbr) {
				if ($shown) $res.=", ";
				$res.="$nmbr $v".is_s($nmbr);
				$shown=true;
			}
		}
		if (!$shown) { $res.="less than one minute"; }
	}
	return $res;
}

function loadavg($return_all=false) {
	$res = "";
	$filename = "/proc/loadavg";
	$fd = fopen ($filename, "r");
	if ($fd===false) {
		$res="Could not retrieve load average";
	} else {
		$loadavg = fgets($fd, 64);
		fclose ($fd);
		$loadavg = explode(" ",$loadavg);
		if ($return_all) {
			$res["last1"] = $loadavg[INTERVAL_1_MIN];
			$res["last5"] = $loadavg[INTERVAL_5_MIN];
			$res["last15"] = $loadavg[INTERVAL_15_MIN];
			$active = explode("/",$loadavg[3]);
			$res["tasks"] = $active[0];
			$res["processes"] = $active[1];
			$res["lastpid"] = $loadavg[4];
		} else {
			$res=$loadavg[DEFAULT_AVG];
		}
	}
	return $res;
}
?>
